/*
 * ADC.c
 *
 * Created: 15.10.2013 20:40:55
 *  Author: Roland
 */ 
#include <avr/io.h>

void Adc_Init(void)
{

	ADCSRB=0; // Right Adjust Data, Unipolar, TS=Free
	ADCSRA=0x80+0x00+0x06; // Enable Adc,Prescaler 256, kein Autotrigger
	DIDR0=0x06;
}

void Adc_SetTriggerSource(uint8_t tsrc)
{
	ADCSRB&=0xf8;
	ADCSRB|=tsrc&0x07;
	return;	
}

void Adc_SetRef(uint8_t ref)
{
	ADMUX&=0x3f;
	ADMUX|=ref&0xc0;
	return;
}

void Adc_SetChannel(uint8_t ch)
{
	ADMUX&=0xc0;
	ADMUX|=ch&0x3f;
	return;
}

void Adc_StartConversion(void)
{
	ADCSRA|=0x10; // Clear ADIF
	ADCSRA|=0x40; // Start Conversion
}	

uint8_t Adc_CheckConversion(void)
{
	return (ADCSRA&0x10);
}

uint16_t Adc_GetResult(void)
{
	return ADC;
}	
