/*
 * Adc.h
 *
 * Created: 15.10.2013 20:41:54
 *  Author: Roland
 */ 


#ifndef ADC_H_
#define ADC_H_

#include <inttypes.h>

extern void Adc_Init(void);


#define ADCTRIGSRC_FREE 0
#define ADCTRIGSRC_ANCOMP 1
#define ADCTRIGSRC_EXTINT0 2
#define ADCTRIGSRC_TC0CMPA 3
#define ADCTRIGSRC_TC0OVL 4
#define ADCTRIGSRC_TC1CMPB 5
#define ADCTRIGSRC_TC1OVL 6
#define ADCTRIGSRC_TC1CAP 7

extern void Adc_SetTriggerSource(uint8_t);

#define ADCREF_VCC 0
#define ADCREF_EXTERNAL_AREF 0x40
#define ADCREF_1V1 0x80


extern void Adc_SetRef(uint8_t);

#define CH_ADC0 0
#define CH_ADC1 1
#define CH_ADC2 2
#define CH_ADC3 3
#define CH_ADC4 4
#define CH_ADC5 5
#define CH_ADC6 6
#define CH_ADC7 7
#define CH_AGND 0x20
#define CH_1V1REF 0x21
#define CH_TEMPERATURE 0x22

#define CH_ADC0_ADC0_G20 0x23
#define CH_ADC1_ADC0_G1 0x08
#define CH_ADC1_ADC0_G20 0x09
#define CH_ADC3_ADC0_G1 00x0a
#define CH_ADC3_ADC0_G 0x0b
#define CH_ADC0_ADC1_G1 0x28
#define CH_ADC0_ADC1_G20 0x29
#define CH_ADCC2_ADC1_G1 0x0c
#define CH_ADCC2_ADC1_G20 0x0d
#define CH_ADC3_ADC1_G1 0x0e
#define CH_ADC3_ADC1_G20 0x0f
#define CH_ADC1_ADC2_G1 0x2c
#define CH_ADC1_ADC2_G20 0x2d
#define CH_ADC3_ADC2_G1 0x10
#define CH_ADC3_ADC2_G20 0x11
#define CH_ADC0_ADC3_G1 0x1a
#define CH_ADC0_ADC3_G20 0x1b
#define CH_ADC1_ADC3_G1 0x0e
#define CH_ADC1_ADC3_G20 0x0f
#define CH_ADC2_ADC3_G1 0x30
#define CH_ADC2_ADC3_G20 0x31
#define CH_ADC3_ADC3_G1 0x24
#define CH_ADC3_ADC3_G20 0x25
#define CH_ADC4_ADC3_G1 0x12
#define CH_ADC4_ADC3_G20 0x13
#define CH_ADC5_ADC3_G1 0x14
#define CH_ADC5_ADC3_G20 0x15
#define CH_ADC6_ADC3_G1 0x16
#define CH_ADC6_ADC3_G20 0x17
#define CH_ADC7_ADC3_G1 0x18
#define CH_ADC7_ADC3_G20 0x19
#define CH_ADC3_ADC4_G1 0x32
#define CH_ADC3_ADC4_G20 0x33
#define CH_ADC5_ADC4_G1 0x1a
#define CH_ADC5_ADC4_G20 0x1b
#define CH_ADC3_ADC5_G1 0x34
#define CH_ADC3_ADC5_G20 0x35
#define CH_ADC4_ADC5_G1 0x3a
#define CH_ADC4_ADC5_G20 0x3b
#define CH_ADC6_ADC5_G1 0x1c
#define CH_ADC6_ADC5_G20 0x1d
#define CH_ADC3_ADC6_G1 0x36
#define CH_ADC3_ADC6_G20 0x37
#define CH_ADC5_ADC6_G1 0x3c
#define CH_ADC5_ADC6_G20 0x3d
#define CH_ADC7_ADC6_G1 0x1e
#define CH_ADC7_ADC6_G20 0x1f
#define CH_ADC3_ADC7_G1 0x38
#define CH_ADC3_ADC7_G20 0x39
#define CH_ADC6_ADC7_G1 0x3e
#define CH_ADC6_ADC7_G20 0x3f
#define CH_ADC7_ADC7_G1 0x26
#define CH_ADC7_ADC7_G20 0x27



extern void Adc_SetChannel(uint8_t);

extern void Adc_StartConversion(void);

extern uint8_t Adc_CheckConversion(void);

#define Adc_WaitConversion() { while (Adc_CheckConversion()==0); }
	
extern uint16_t Adc_GetResult(void);	

#endif /* ADC_H_ */