/*
 * MessTrans.c
 *
 * Created: 20.05.2012 20:12:45
 *  Author: Roland
 */ 

#include <avr/io.h>
#include "Clk.h"
#include "Timer.h"
#include "Scale.h"
#include "RFM70.h"
#include "Adc.h"


// HW Nutzung
// (2) PB0/PCINT8 /IRQ
// (3) PB1: /CE
// (6) PA7/ICP: SLDATA
// (7) PA6/MOSI
// (8) PA5/MISO
// (9) PA4/SCK
// (10) PA3/T0 SLCLK
// (11) PA2: CSN
// (12) PA1/ADC1: VSup/4


uint32_t a,b;
uint8_t r1,r2,r3;
uint16_t t1,t2,t3,t4;
uint32_t pos;
uint16_t adcbat;

struct {
	uint32_t RawPosition;
	uint16_t BatVoltage;
} Rfm70TxPayload;

#define RF70_PL_SIZE 6	


static uint32_t BitRev24(uint32_t x)
{
	uint8_t n;
	uint32_t x1;

	// Bitreihenfolge umdrehen
	x1=0;
	for(n=0;n<24;n++)
	{
		x1>>=1;
		if(x&0x80000000) x1|=0x800000;
		x<<=1;
	}
	return x1;
}


int main(void)
{
	//PORTB|=0x02; // /CE=H
	//DDRB=0x02; 
	//PORTA|=0x04; // /CSN=H
	//DDRB=0x04;
	
	
	Clk_Init();
	Timer_Init();
	Adc_Init();
	Scale_Init();
	init_port();
	RFM70_Initialize();
	
	Adc_SetRef(ADCREF_1V1);
	Adc_SetTriggerSource(ADCTRIGSRC_FREE);
	Adc_SetChannel(CH_ADC1);
	
	
    while(1)
    {
	Adc_StartConversion();
	Adc_WaitConversion();
	adcbat=Adc_GetResult();
	
		
	//t1=Timer_GetTime();	
	r1=Scale_WaitStart();
	//t2=Timer_GetTime();	
#ifndef notdef
	r2=Scale_Get24Bit(&a);
	//t3=Timer_GetTime();
#endif		
	r3=Scale_Get24Bit(&b);
	//t4=Timer_GetTime();
	
	b=BitRev24(b);
	
	Adc_WaitConversion();
	adcbat=Adc_GetResult();

	Rfm70TxPayload.RawPosition=b;
	Rfm70TxPayload.BatVoltage=adcbat; // Umrechnung ?
		
	Send_Packet(W_TX_PAYLOAD_NOACK_CMD,(unsigned char*)&Rfm70TxPayload,RF70_PL_SIZE);
	//SwitchToRxMode();  //switch to Rx mode
	
	Timer_Delayms(30);
	Send_Packet(W_TX_PAYLOAD_NOACK_CMD,(unsigned char*)&Rfm70TxPayload,RF70_PL_SIZE);

	Timer_Delayms(30);
	Send_Packet(W_TX_PAYLOAD_NOACK_CMD,(unsigned char*)&Rfm70TxPayload,RF70_PL_SIZE);
	
	
	
	//pos=((int32_t)b)*127/1024; // Position in 10 um Schritten berechnen
	
	//Timer_Delayms(1000);


	}
}