/*
 * Scale.c
 *
 * Created: 04.06.2012 16:59:02
 *  Author: Roland
 */ 

// HW Abstraktionsschicht

#include <avr/io.h>
#include "Timer.h"




#define USE_USI 1

#if USE_USI==1
#include "Usi.h"
#endif


void Scale_Init(void)
{
	DDRA&=~0x50; // PA6 und PA4 auf Input;
	PORTA|=(1<<PA6)+(1<<PA4); // Enable Pullups PA3,PA7
#if USE_USI==1
	Usi_Init(CLK_RISING);
#endif	
	return;
}


#define Scale_Clk() ((PINA&(1<<PA4)) ? 0 : 1) 



#define Scale_Data() ((PINA&(1<<PA6)) ? 1:0) // PA7 Muss invertiert werden !
	


// Signalauswertungs Schicht

uint8_t Scale_WaitStart()
{
	
	time_t t1,t2;
	t1=Timer_GetTime();
	t2=t1;
	do
	{
		if(Timer_Timeout(t1,1000)) return 1;
#if USE_USI==0
		if(Scale_Clk()==1) t2=Timer_GetTime(); 
#else
		if(Usi_CheckStart())
		{
			t2=Timer_GetTime();
			Usi_Reset();
		}
#endif
	} while (Timer_Timeout(t2,100)==0);
	
	return 0;
}	

#if USE_USI==0
uint8_t Scale_Get24Bit(uint32_t *a)
{
	uint32_t res,mask;
	uint8_t n;
	res=0;
	mask=0x01;
	
	// erste Version noch ohne Timeouts
	
	for(n=0;n<24;n++)
		{
			while(Scale_Clk()==0); // Warten bis Clk=Hi
			
			while(Scale_Clk()!=0); // Warten auf fallene Flanke Clk
			
			if(Scale_Data()!=0) res|=mask;
			
			mask<<=1;
			
		}
		
	*a=res;
	return 0;	
}
	
#endif

#if USE_USI==1
uint8_t Scale_Get24Bit(uint32_t *a)
{
	uint32_t res;
	
	
	res=0;
	
	while(!Usi_CheckC());
	res|=(uint32_t)Usi_GetC()<<24;

	while(!Usi_CheckC());
	res|=(uint32_t)Usi_GetC()<<16;

	while(!Usi_CheckC());
	res|=(uint32_t)Usi_GetC()<<8;


	if(a) *a=res;//^0xffffff00; // Daten invertieren nur fr TYPE_24BIT1 !!!

	return 0;
}


#endif	

	// 1. Warten bis clk >100 us auf 0 bleibt TO=1ms
	// 2. Warten bis Clk auf 1 geht, TO=1ms
	//  
	// 3. Warten bis Clk auf Lo geht, 1 DB einlesen TO=100 us
	// 4. Warten bis Clk auf 1 TO=
	// 5. Warten bis Clk auf 0 dann naechstes DB lesen TO=
	// Weiter bei 4. bis alle 24 Bit gelesen -> *a
	
	// Wiederhole Block 3.-5. fr 2. 24 Bit Wort ->*b
	

