/*
 * Spi.c
 *
 * Created: 04.06.2012 16:56:23
 *  Author: Roland
 */ 

#include <avr/io.h>
#include "Spi.h"

void Spi_Init(void)
{
	USICR=0;
	PORTA&=0xff-(1<<PA4); // CLK Lo
	PORTA|=1<<PA2; // /CSN auf Hi
	DDRA|=(1<<PA2)+(1<<PA4)+(1<<PA6); // CSN, SCK und MOSI out
	
}

void Spi_TxRx(uint8_t out, uint8_t *in)
{
	USISR=1<<USIOIF;
	USIDR=out;
	USICR=(1<<USIWM0)+(0<<USIWM1)+(1<USICLK)+(1<<USITC);
	USICR=(1<<USIWM0)+(0<<USIWM1)+(1<USICLK)+(1<<USITC);
	USICR=(1<<USIWM0)+(0<<USIWM1)+(1<USICLK)+(1<<USITC);
	USICR=(1<<USIWM0)+(0<<USIWM1)+(1<USICLK)+(1<<USITC);
	USICR=(1<<USIWM0)+(0<<USIWM1)+(1<USICLK)+(1<<USITC);
	USICR=(1<<USIWM0)+(0<<USIWM1)+(1<USICLK)+(1<<USITC);
	USICR=(1<<USIWM0)+(0<<USIWM1)+(1<USICLK)+(1<<USITC);
	USICR=(1<<USIWM0)+(0<<USIWM1)+(1<USICLK)+(1<<USITC);
	if(in) *in=USIDR;
	return;	
}	

void Spi_SetCsn(uint8_t d)
{
	if(d) PORTA|=1<<PA2;
	else PORTA&=0xff-(1<<PA2);
	return;	
}	
