/*
 * Timer.c
 *
 * Created: 05.06.2012 20:22:07
 *  Author: Roland
 */ 

#include <avr/io.h>
#include "Timer.h"

void Timer_Init(void)
{
	TCCR1A=0x00;
	TCCR1B=0x02; // 1= /1, 2= /8 Prescaler
	TCCR1C=0x00;
	TIMSK1=0x00; // Disable Interrupts
	
	return;
}


uint16_t Timer_GetTime(void)
{
	
	return TCNT1;
}


uint8_t Timer_Timeout(uint16_t t1,uint16_t tout)
{
	
	time_t t,t2;
	t=Timer_GetTime();
	
	t2=t1+tout;
	
	if(t2>t1)
	{
		if(t>=t2 || t<t1) return 1;
		else return 0;
	}
	else
	{
		if(t>=t2 && t<t1) return 1;
		else return 0;
	}
	
	return 2;
}

void Timer_Delayus(uint16_t us)
{
	uint16_t t1;
	
	t1=Timer_GetTime();
	while(Timer_Timeout(t1,us)==0);
	return;
}

void Timer_Delayms(uint16_t ms)
{
	uint16_t n;
	
	for(n=0;n<ms;n++)
	{
		Timer_Delayus(1000);
	}
	return;
}